SDL_test_fuzzer.h File Reference
`#include "begin_code.h"`
`#include "close_code.h"`
Include dependency graph for SDL_test_fuzzer.h:
This graph shows which files directly or indirectly include this file:

Go to the source code of this file.

## Functions

void | SDLTest_FuzzerInit (Uint64 execKey)
Uint8 | SDLTest_RandomUint8 (void)
Sint8 | SDLTest_RandomSint8 (void)
Uint16 | SDLTest_RandomUint16 (void)
Sint16 | SDLTest_RandomSint16 (void)
Sint32 | SDLTest_RandomSint32 (void)
Uint32 | SDLTest_RandomUint32 (void)
Uint64 | SDLTest_RandomUint64 (void)
Sint64 | SDLTest_RandomSint64 (void)
float | SDLTest_RandomUnitFloat (void)
double | SDLTest_RandomUnitDouble (void)
float | SDLTest_RandomFloat (void)
double | SDLTest_RandomDouble (void)
Uint8 | SDLTest_RandomUint8BoundaryValue (Uint8 boundary1, Uint8 boundary2, SDL_bool validDomain)
Uint16 | SDLTest_RandomUint16BoundaryValue (Uint16 boundary1, Uint16 boundary2, SDL_bool validDomain)
Uint32 | SDLTest_RandomUint32BoundaryValue (Uint32 boundary1, Uint32 boundary2, SDL_bool validDomain)
Uint64 | SDLTest_RandomUint64BoundaryValue (Uint64 boundary1, Uint64 boundary2, SDL_bool validDomain)
Sint8 | SDLTest_RandomSint8BoundaryValue (Sint8 boundary1, Sint8 boundary2, SDL_bool validDomain)
Sint16 | SDLTest_RandomSint16BoundaryValue (Sint16 boundary1, Sint16 boundary2, SDL_bool validDomain)
Sint32 | SDLTest_RandomSint32BoundaryValue (Sint32 boundary1, Sint32 boundary2, SDL_bool validDomain)
Sint64 | SDLTest_RandomSint64BoundaryValue (Sint64 boundary1, Sint64 boundary2, SDL_bool validDomain)
Sint32 | SDLTest_RandomIntegerInRange (Sint32 min, Sint32 max)
char * | SDLTest_RandomAsciiString (void)
char * | SDLTest_RandomAsciiStringWithMaximumLength (int maxLength)
char * | SDLTest_RandomAsciiStringOfSize (int size)
int | SDLTest_GetFuzzerInvocationCount (void)

## Detailed Description

Include file for SDL test framework.

This code is a part of the SDL2_test library, not the main SDL library.

Note: The fuzzer implementation uses a static instance of random context internally which makes it thread-UNsafe.

Definition in file SDL_test_fuzzer.h.

## Function Documentation

## SDLTest_FuzzerInit()

void SDLTest_FuzzerInit | ( | Uint64 | execKey | ) |

Initializes the fuzzer for a test

Parameters

  execKey | Execution "Key" that initializes the random number generator uniquely for the test.

Definition at line 63 of file SDL_test_fuzzer.c.

{
Uint32 a = (execKey >> 32) & 0x00000000FFFFFFFF;
Uint32 b = execKey & 0x00000000FFFFFFFF;
SDL_memset((void *)&rndContext, 0, sizeof(SDLTest_RandomContext));
SDLTest_RandomInit(&rndContext, a, b);
fuzzerInvocationCounter = 0;
}

References fuzzerInvocationCounter, rndContext, SDL_memset, and SDLTest_RandomInit().

Referenced by main(), and SDLTest_RunTest().

## SDLTest_GetFuzzerInvocationCount()

int SDLTest_GetFuzzerInvocationCount | ( | void |  | ) |

Returns the invocation count for the fuzzer since last ...FuzzerInit.

Definition at line 73 of file SDL_test_fuzzer.c.

{
return fuzzerInvocationCounter;
}

References fuzzerInvocationCounter.

Referenced by sdltest_getFuzzerInvocationCount(), and SDLTest_RunTest().

## SDLTest_RandomAsciiString()

char* SDLTest_RandomAsciiString | ( | void |  | ) |

Generates random null-terminated string. The minimum length for the string is 1 character, maximum length for the string is 255 characters and it can contain ASCII characters from 32 to 126.

Note: Returned string needs to be deallocated.

Returns
  Newly allocated random string; or NULL if length was invalid or string could not be allocated.

Definition at line 486 of file SDL_test_fuzzer.c.

{
return SDLTest_RandomAsciiStringWithMaximumLength(255);
}

References SDLTest_RandomAsciiStringWithMaximumLength().

Referenced by clipboard_testClipboardTextFunctions(), clipboard_testSetClipboardText(), and sdltest_randomAsciiString().

## SDLTest_RandomAsciiStringOfSize()

char* SDLTest_RandomAsciiStringOfSize | ( | int | size | ) |

Generates random null-terminated string. The length for the string is defined by the size parameter. String can contain ASCII characters from 32 to 126.

Note: Returned string needs to be deallocated.

Parameters

  size | The length of the generated string

Returns
  Newly allocated random string; or NULL if size was invalid or string could not be allocated.

Definition at line 507 of file SDL_test_fuzzer.c.

{
char *string;
int counter;
if(size < 1) {
SDL_InvalidParamError("size");
return NULL;
}
string = (char *)SDL_malloc((size + 1) * sizeof(char));
if (string==NULL) {
return NULL;
}
for(counter = 0; counter < size; ++counter) {
string[counter] = (char)SDLTest_RandomIntegerInRange(32, 126);
}
string[counter] = '\0';
fuzzerInvocationCounter++;
return string;
}

References fuzzerInvocationCounter, NULL, SDL_InvalidParamError, SDL_malloc, and SDLTest_RandomIntegerInRange().

Referenced by hints_setHint(), keyboard_getScancodeFromNameNegative(), sdltest_randomAsciiStringOfSize(), SDLTest_RandomAsciiStringWithMaximumLength(), stdlib_getsetenv(), and video_getSetWindowData().

## SDLTest_RandomAsciiStringWithMaximumLength()

char* SDLTest_RandomAsciiStringWithMaximumLength | ( | int | maxLength | ) |

Generates random null-terminated string. The maximum length for the string is defined by the maxLength parameter. String can contain ASCII characters from 32 to 126.

Note: Returned string needs to be deallocated.

Parameters

  maxLength | The maximum length of the generated string.

Returns
  Newly allocated random string; or NULL if maxLength was invalid or string could not be allocated.

Definition at line 492 of file SDL_test_fuzzer.c.

{
int size;
if(maxLength < 1) {
SDL_InvalidParamError("maxLength");
return NULL;
}
size = (SDLTest_RandomUint32() % (maxLength + 1));
return SDLTest_RandomAsciiStringOfSize(size);
}

References NULL, SDL_InvalidParamError, SDLTest_RandomAsciiStringOfSize(), and SDLTest_RandomUint32().

Referenced by SDLTest_RandomAsciiString(), and sdltest_randomAsciiStringWithMaximumLength().

## SDLTest_RandomDouble()

double SDLTest_RandomDouble | ( | void |  | ) |

Returns
  random double.

Definition at line 470 of file SDL_test_fuzzer.c.

{
double r = 0.0;
double s = 1.0;
do {
s /= UINT_MAX + 1.0;
r += (double)SDLTest_RandomInt(&rndContext) * s;
} while (s > DBL_EPSILON);
fuzzerInvocationCounter++;
return r;
}

References fuzzerInvocationCounter, rndContext, and SDLTest_RandomInt.

Referenced by sdltest_randomNumber().

## SDLTest_RandomFloat()

float SDLTest_RandomFloat | ( | void |  | ) |

Returns
  random float.

Definition at line 458 of file SDL_test_fuzzer.c.

{
return (float) (SDLTest_RandomUnitDouble() * (double)2.0 * (double)FLT_MAX - (double)(FLT_MAX));
}

References SDLTest_RandomUnitDouble().

Referenced by sdltest_randomNumber().

## SDLTest_RandomIntegerInRange()

Sint32 SDLTest_RandomIntegerInRange | ( | Sint32 | min,
|  | Sint32 | max
| ) |  |

Returns integer in range [min, max] (inclusive). Min and max values can be negative values. If Max in smaller than min, then the values are swapped. Min and max are the same value, that value will be returned.

Parameters

  min | Minimum inclusive value of returned random number
  max | Maximum inclusive value of returned random number

Returns
  Generated random integer in range

Definition at line 163 of file SDL_test_fuzzer.c.

{
Sint64 min = pMin;
Sint64 max = pMax;
Sint64 temp;
Sint64 number;
if(pMin > pMax) {
temp = min;
min = max;
max = temp;
} else if(pMin == pMax) {
return (Sint32)min;
}
number = SDLTest_RandomUint32();
/* invocation count increment in preceeding call */
return (Sint32)((number % ((max + 1) - min)) + min);
}

References SDLTest_RandomUint32().

Referenced by _createVideoSuiteTestWindow(), _testGenericRWopsValidations(), audio_buildAudioCVT(), audio_convertAudio(), audio_enumerateAndNameAudioDevices(), audio_enumerateAndNameAudioDevicesNegativeTests(), audio_pauseUnpauseAudio(), events_addDelEventWatchWithUserdata(), keyboard_getKeyNameNegative(), keyboard_getSetModState(), keyboard_setTextInputRect(), main(), mouse_getMouseFocus(), mouse_warpMouseInWindow(), pixels_allocFreePalette(), pixels_calcGammaRamp(), rect_testEnclosePoints(), rect_testEnclosePointsParam(), rect_testEnclosePointsRepeatedInput(), rect_testEnclosePointsWithClipping(), rect_testHasIntersectionEmpty(), rect_testHasIntersectionInside(), rect_testHasIntersectionOutside(), rect_testHasIntersectionPartial(), rect_testHasIntersectionPoint(), rect_testIntersectRectAndLine(), rect_testIntersectRectAndLineEmpty(), rect_testIntersectRectAndLineInside(), rect_testIntersectRectAndLineOutside(), rect_testIntersectRectEmpty(), rect_testIntersectRectInside(), rect_testIntersectRectOutside(), rect_testIntersectRectPartial(), rect_testIntersectRectPoint(), rect_testRectEmpty(), rect_testRectEquals(), rect_testRectEqualsParam(), rect_testUnionRectEmpty(), rect_testUnionRectInside(), rect_testUnionRectOutside(), SDLTest_RandomAsciiStringOfSize(), sdltest_randomIntegerInRange(), stdlib_getsetenv(), timer_addRemoveTimer(), timer_delayAndGetTicks(), video_createWindowVariousFlags(), video_createWindowVariousPositions(), video_createWindowVariousSizes(), video_getClosestDisplayModeRandomResolution(), video_getNumDisplayModesNegative(), video_getSetWindowData(), video_getSetWindowMaximumSize(), video_getSetWindowMinimumSize(), video_getSetWindowPosition(), video_getSetWindowSize(), and video_getWindowId().

## SDLTest_RandomSint16()

Sint16 SDLTest_RandomSint16 | ( | void |  | ) |

Returns a random Sint16

Returns
  Generated signed integer

Definition at line 103 of file SDL_test_fuzzer.c.

{
fuzzerInvocationCounter++;
return (Sint16) SDLTest_RandomInt(&rndContext) & 0x0000FFFF;
}

References fuzzerInvocationCounter, rndContext, and SDLTest_RandomInt.

Referenced by sdltest_randomIntegerInRange(), and sdltest_randomNumber().

## SDLTest_RandomSint16BoundaryValue()

Sint16 SDLTest_RandomSint16BoundaryValue | ( | Sint16 | boundary1,
|  | Sint16 | boundary2,
|  | SDL_bool | validDomain
| ) |  |

Returns a random boundary value for Sint16 within the given boundaries. Boundaries are inclusive, see the usage examples below. If validDomain is true, the function will only return valid boundaries, otherwise non-valid boundaries are also possible. If boundary1 > boundary2, the values are swapped

Usage examples: RandomSint16BoundaryValue(-10, 20, SDL_TRUE) returns -11, -10, 19 or 20 RandomSint16BoundaryValue(-100, -10, SDL_FALSE) returns -101 or -9 RandomSint16BoundaryValue(SINT16_MIN, 99, SDL_FALSE) returns 100 RandomSint16BoundaryValue(SINT16_MIN, SINT16_MAX, SDL_FALSE) returns SINT16_MIN (== error value) with error set

Parameters

  boundary1 | Lower boundary limit
  boundary2 | Upper boundary limit
  validDomain | Should the generated boundary be valid (=within the bounds) or not?

Returns
  Random boundary value for the given range and domain or SINT16_MIN with error set

Definition at line 414 of file SDL_test_fuzzer.c.

{
/* min & max values for Sint16 */
const Sint64 maxValue = SHRT_MAX;
const Sint64 minValue = SHRT_MIN;
return (Sint16)SDLTest_GenerateSignedBoundaryValues(minValue, maxValue,
(Sint64) boundary1, (Sint64) boundary2,
validDomain);
}

References SDLTest_GenerateSignedBoundaryValues().

Referenced by sdltest_randomBoundaryNumberSint16().

## SDLTest_RandomSint32()

Sint32 SDLTest_RandomSint32 | ( | void |  | ) |

Returns a random integer

Returns
  Generated integer

Definition at line 111 of file SDL_test_fuzzer.c.

{
fuzzerInvocationCounter++;
return (Sint32) SDLTest_RandomInt(&rndContext);
}

References fuzzerInvocationCounter, rndContext, and SDLTest_RandomInt.

Referenced by events_addDelEventWatch(), events_addDelEventWatchWithUserdata(), events_pushPumpAndPollUserevent(), sdltest_randomNumber(), SDLTest_RandomSint64(), SDLTest_RandomUint64(), video_getSetWindowMaximumSize(), video_getSetWindowMinimumSize(), video_getSetWindowPosition(), and video_getSetWindowSize().

## SDLTest_RandomSint32BoundaryValue()

Sint32 SDLTest_RandomSint32BoundaryValue | ( | Sint32 | boundary1,
|  | Sint32 | boundary2,
|  | SDL_bool | validDomain
| ) |  |

Returns a random boundary value for Sint32 within the given boundaries. Boundaries are inclusive, see the usage examples below. If validDomain is true, the function will only return valid boundaries, otherwise non-valid boundaries are also possible. If boundary1 > boundary2, the values are swapped

Usage examples: RandomSint32BoundaryValue(-10, 20, SDL_TRUE) returns -11, -10, 19 or 20 RandomSint32BoundaryValue(-100, -10, SDL_FALSE) returns -101 or -9 RandomSint32BoundaryValue(SINT32_MIN, 99, SDL_FALSE) returns 100 RandomSint32BoundaryValue(SINT32_MIN, SINT32_MAX, SDL_FALSE) returns SINT32_MIN (== error value)

Parameters

  boundary1 | Lower boundary limit
  boundary2 | Upper boundary limit
  validDomain | Should the generated boundary be valid (=within the bounds) or not?

Returns
  Random boundary value for the given range and domain or SINT32_MIN with error set

Definition at line 425 of file SDL_test_fuzzer.c.

{
/* min & max values for Sint32 */
#if ((ULONG_MAX) == (UINT_MAX))
const Sint64 maxValue = LONG_MAX;
const Sint64 minValue = LONG_MIN;
#else
const Sint64 maxValue = INT_MAX;
const Sint64 minValue = INT_MIN;
#endif
return (Sint32)SDLTest_GenerateSignedBoundaryValues(minValue, maxValue,
(Sint64) boundary1, (Sint64) boundary2,
validDomain);
}

References INT_MAX, and SDLTest_GenerateSignedBoundaryValues().

Referenced by sdltest_randomBoundaryNumberSint32(), and video_getNumDisplayModesNegative().

## SDLTest_RandomSint64()

Sint64 SDLTest_RandomSint64 | ( | void |  | ) |

Returns random Sint64.

Returns
  Generated signed integer

Definition at line 144 of file SDL_test_fuzzer.c.

{
union {
Uint64 v64;
Uint32 v32[2];
} value;
value.v64 = 0;
fuzzerInvocationCounter++;
value.v32[0] = SDLTest_RandomSint32();
value.v32[1] = SDLTest_RandomSint32();
return (Sint64)value.v64;
}

References fuzzerInvocationCounter, and SDLTest_RandomSint32().

Referenced by sdltest_randomNumber().

## SDLTest_RandomSint64BoundaryValue()

Sint64 SDLTest_RandomSint64BoundaryValue | ( | Sint64 | boundary1,
|  | Sint64 | boundary2,
|  | SDL_bool | validDomain
| ) |  |

Returns a random boundary value for Sint64 within the given boundaries. Boundaries are inclusive, see the usage examples below. If validDomain is true, the function will only return valid boundaries, otherwise non-valid boundaries are also possible. If boundary1 > boundary2, the values are swapped

Usage examples: RandomSint64BoundaryValue(-10, 20, SDL_TRUE) returns -11, -10, 19 or 20 RandomSint64BoundaryValue(-100, -10, SDL_FALSE) returns -101 or -9 RandomSint64BoundaryValue(SINT64_MIN, 99, SDL_FALSE) returns 100 RandomSint64BoundaryValue(SINT64_MIN, SINT64_MAX, SDL_FALSE) returns SINT64_MIN (== error value) and error set

Parameters

  boundary1 | Lower boundary limit
  boundary2 | Upper boundary limit
  validDomain | Should the generated boundary be valid (=within the bounds) or not?

Returns
  Random boundary value for the given range and domain or SINT64_MIN with error set

Definition at line 441 of file SDL_test_fuzzer.c.

{
/* min & max values for Sint64 */
const Sint64 maxValue = INT64_MAX;
const Sint64 minValue = INT64_MIN;
return SDLTest_GenerateSignedBoundaryValues(minValue, maxValue,
boundary1, boundary2,
validDomain);
}

References SDLTest_GenerateSignedBoundaryValues().

Referenced by sdltest_randomBoundaryNumberSint64().

## SDLTest_RandomSint8()

Sint8 SDLTest_RandomSint8 | ( | void |  | ) |

Returns a random Sint8

Returns
  Generated signed integer

Definition at line 87 of file SDL_test_fuzzer.c.

{
fuzzerInvocationCounter++;
return (Sint8) SDLTest_RandomInt(&rndContext) & 0x000000FF;
}

References fuzzerInvocationCounter, rndContext, and SDLTest_RandomInt.

Referenced by sdltest_randomNumber().

## SDLTest_RandomSint8BoundaryValue()

Sint8 SDLTest_RandomSint8BoundaryValue | ( | Sint8 | boundary1,
|  | Sint8 | boundary2,
|  | SDL_bool | validDomain
| ) |  |

Returns a random boundary value for Sint8 within the given boundaries. Boundaries are inclusive, see the usage examples below. If validDomain is true, the function will only return valid boundaries, otherwise non-valid boundaries are also possible. If boundary1 > boundary2, the values are swapped

Usage examples: RandomSint8BoundaryValue(-10, 20, SDL_TRUE) returns -11, -10, 19 or 20 RandomSint8BoundaryValue(-100, -10, SDL_FALSE) returns -101 or -9 RandomSint8BoundaryValue(SINT8_MIN, 99, SDL_FALSE) returns 100 RandomSint8BoundaryValue(SINT8_MIN, SINT8_MAX, SDL_FALSE) returns SINT8_MIN (== error value) with error set

Parameters

  boundary1 | Lower boundary limit
  boundary2 | Upper boundary limit
  validDomain | Should the generated boundary be valid (=within the bounds) or not?

Returns
  Random boundary value for the given range and domain or SINT8_MIN with error set

Definition at line 403 of file SDL_test_fuzzer.c.

{
/* min & max values for Sint8 */
const Sint64 maxValue = SCHAR_MAX;
const Sint64 minValue = SCHAR_MIN;
return (Sint8)SDLTest_GenerateSignedBoundaryValues(minValue, maxValue,
(Sint64) boundary1, (Sint64) boundary2,
validDomain);
}

References SDLTest_GenerateSignedBoundaryValues().

Referenced by sdltest_randomBoundaryNumberSint8().

## SDLTest_RandomUint16()

Uint16 SDLTest_RandomUint16 | ( | void |  | ) |

Returns a random Uint16

Returns
  Generated integer

Definition at line 95 of file SDL_test_fuzzer.c.

{
fuzzerInvocationCounter++;
return (Uint16) SDLTest_RandomInt(&rndContext) & 0x0000FFFF;
}

References fuzzerInvocationCounter, rndContext, and SDLTest_RandomInt.

Referenced by rwops_testFileWriteReadEndian(), and sdltest_randomNumber().

## SDLTest_RandomUint16BoundaryValue()

Uint16 SDLTest_RandomUint16BoundaryValue | ( | Uint16 | boundary1,
|  | Uint16 | boundary2,
|  | SDL_bool | validDomain
| ) |  |

Returns a random boundary value for Uint16 within the given boundaries. Boundaries are inclusive, see the usage examples below. If validDomain is true, the function will only return valid boundaries, otherwise non-valid boundaries are also possible. If boundary1 > boundary2, the values are swapped

Usage examples: RandomUint16BoundaryValue(10, 20, SDL_TRUE) returns 10, 11, 19 or 20 RandomUint16BoundaryValue(1, 20, SDL_FALSE) returns 0 or 21 RandomUint16BoundaryValue(0, 99, SDL_FALSE) returns 100 RandomUint16BoundaryValue(0, 0xFFFF, SDL_FALSE) returns 0 (error set)

Parameters

  boundary1 | Lower boundary limit
  boundary2 | Upper boundary limit
  validDomain | Should the generated boundary be valid (=within the bounds) or not?

Returns
  Random boundary value for the given range and domain or 0 with error set

Definition at line 281 of file SDL_test_fuzzer.c.

{
/* max value for Uint16 */
const Uint64 maxValue = USHRT_MAX;
return (Uint16)SDLTest_GenerateUnsignedBoundaryValues(maxValue,
(Uint64) boundary1, (Uint64) boundary2,
validDomain);
}

References SDLTest_GenerateUnsignedBoundaryValues().

Referenced by sdltest_randomBoundaryNumberUint16().

## SDLTest_RandomUint32()

Uint32 SDLTest_RandomUint32 | ( | void |  | ) |

Returns a random positive integer

Returns
  Generated integer

Definition at line 119 of file SDL_test_fuzzer.c.

{
fuzzerInvocationCounter++;
return (Uint32) SDLTest_RandomInt(&rndContext);
}

References fuzzerInvocationCounter, rndContext, and SDLTest_RandomInt.

Referenced by rwops_testFileWriteReadEndian(), SDLTest_RandomAsciiStringWithMaximumLength(), SDLTest_RandomIntegerInRange(), sdltest_randomNumber(), and SDLTest_RandomUnitFloat().

## SDLTest_RandomUint32BoundaryValue()

Uint32 SDLTest_RandomUint32BoundaryValue | ( | Uint32 | boundary1,
|  | Uint32 | boundary2,
|  | SDL_bool | validDomain
| ) |  |

Returns a random boundary value for Uint32 within the given boundaries. Boundaries are inclusive, see the usage examples below. If validDomain is true, the function will only return valid boundaries, otherwise non-valid boundaries are also possible. If boundary1 > boundary2, the values are swapped

Usage examples: RandomUint32BoundaryValue(10, 20, SDL_TRUE) returns 10, 11, 19 or 20 RandomUint32BoundaryValue(1, 20, SDL_FALSE) returns 0 or 21 RandomUint32BoundaryValue(0, 99, SDL_FALSE) returns 100 RandomUint32BoundaryValue(0, 0xFFFFFFFF, SDL_FALSE) returns 0 (with error set)

Parameters

  boundary1 | Lower boundary limit
  boundary2 | Upper boundary limit
  validDomain | Should the generated boundary be valid (=within the bounds) or not?

Returns
  Random boundary value for the given range and domain or 0 with error set

Definition at line 291 of file SDL_test_fuzzer.c.

{
/* max value for Uint32 */
#if ((ULONG_MAX) == (UINT_MAX))
const Uint64 maxValue = ULONG_MAX;
#else
const Uint64 maxValue = UINT_MAX;
#endif
return (Uint32)SDLTest_GenerateUnsignedBoundaryValues(maxValue,
(Uint64) boundary1, (Uint64) boundary2,
validDomain);
}

References SDLTest_GenerateUnsignedBoundaryValues().

Referenced by sdltest_randomBoundaryNumberUint32().

## SDLTest_RandomUint64()

Uint64 SDLTest_RandomUint64 | ( | void |  | ) |

Returns random Uint64.

Returns
  Generated integer

Definition at line 127 of file SDL_test_fuzzer.c.

{
union {
Uint64 v64;
Uint32 v32[2];
} value;
value.v64 = 0;
fuzzerInvocationCounter++;
value.v32[0] = SDLTest_RandomSint32();
value.v32[1] = SDLTest_RandomSint32();
return value.v64;
}

References fuzzerInvocationCounter, and SDLTest_RandomSint32().

Referenced by rwops_testFileWriteReadEndian(), sdltest_randomNumber(), and SDLTest_RandomUnitDouble().

## SDLTest_RandomUint64BoundaryValue()

Uint64 SDLTest_RandomUint64BoundaryValue | ( | Uint64 | boundary1,
|  | Uint64 | boundary2,
|  | SDL_bool | validDomain
| ) |  |

Returns a random boundary value for Uint64 within the given boundaries. Boundaries are inclusive, see the usage examples below. If validDomain is true, the function will only return valid boundaries, otherwise non-valid boundaries are also possible. If boundary1 > boundary2, the values are swapped

Usage examples: RandomUint64BoundaryValue(10, 20, SDL_TRUE) returns 10, 11, 19 or 20 RandomUint64BoundaryValue(1, 20, SDL_FALSE) returns 0 or 21 RandomUint64BoundaryValue(0, 99, SDL_FALSE) returns 100 RandomUint64BoundaryValue(0, 0xFFFFFFFFFFFFFFFF, SDL_FALSE) returns 0 (with error set)

Parameters

  boundary1 | Lower boundary limit
  boundary2 | Upper boundary limit
  validDomain | Should the generated boundary be valid (=within the bounds) or not?

Returns
  Random boundary value for the given range and domain or 0 with error set

Definition at line 305 of file SDL_test_fuzzer.c.

{
/* max value for Uint64 */
const Uint64 maxValue = UINT64_MAX;
return SDLTest_GenerateUnsignedBoundaryValues(maxValue,
(Uint64) boundary1, (Uint64) boundary2,
validDomain);
}

References SDLTest_GenerateUnsignedBoundaryValues(), and UINT64_MAX.

Referenced by sdltest_randomBoundaryNumberUint64().

## SDLTest_RandomUint8()

Uint8 SDLTest_RandomUint8 | ( | void |  | ) |

Returns a random Uint8

Returns
  Generated integer

Definition at line 79 of file SDL_test_fuzzer.c.

{
fuzzerInvocationCounter++;
return (Uint8) SDLTest_RandomInt(&rndContext) & 0x000000FF;
}

References fuzzerInvocationCounter, rndContext, and SDLTest_RandomInt.

Referenced by SDLTest_GenerateSignedBoundaryValues(), SDLTest_GenerateUnsignedBoundaryValues(), sdltest_getFuzzerInvocationCount(), sdltest_randomAsciiStringOfSize(), sdltest_randomAsciiStringWithMaximumLength(), sdltest_randomIntegerInRange(), and sdltest_randomNumber().

## SDLTest_RandomUint8BoundaryValue()

Uint8 SDLTest_RandomUint8BoundaryValue | ( | Uint8 | boundary1,
|  | Uint8 | boundary2,
|  | SDL_bool | validDomain
| ) |  |

Returns a random boundary value for Uint8 within the given boundaries. Boundaries are inclusive, see the usage examples below. If validDomain is true, the function will only return valid boundaries, otherwise non-valid boundaries are also possible. If boundary1 > boundary2, the values are swapped

Usage examples: RandomUint8BoundaryValue(10, 20, SDL_TRUE) returns 10, 11, 19 or 20 RandomUint8BoundaryValue(1, 20, SDL_FALSE) returns 0 or 21 RandomUint8BoundaryValue(0, 99, SDL_FALSE) returns 100 RandomUint8BoundaryValue(0, 255, SDL_FALSE) returns 0 (error set)

Parameters

  boundary1 | Lower boundary limit
  boundary2 | Upper boundary limit
  validDomain | Should the generated boundary be valid (=within the bounds) or not?

Returns
  Random boundary value for the given range and domain or 0 with error set

Definition at line 271 of file SDL_test_fuzzer.c.

{
/* max value for Uint8 */
const Uint64 maxValue = UCHAR_MAX;
return (Uint8)SDLTest_GenerateUnsignedBoundaryValues(maxValue,
(Uint64) boundary1, (Uint64) boundary2,
validDomain);
}

References SDLTest_GenerateUnsignedBoundaryValues().

Referenced by sdltest_randomBoundaryNumberUint8().

## SDLTest_RandomUnitDouble()

double SDLTest_RandomUnitDouble | ( | void |  | ) |

Returns
  random double in range [0.0 - 1.0[

Definition at line 464 of file SDL_test_fuzzer.c.

{
return (double) (SDLTest_RandomUint64() >> 11) * (1.0/9007199254740992.0);
}

References SDLTest_RandomUint64().

Referenced by SDLTest_RandomFloat(), and sdltest_randomNumber().

## SDLTest_RandomUnitFloat()

float SDLTest_RandomUnitFloat | ( | void |  | ) |

Returns
  random float in range [0.0 - 1.0[

Definition at line 452 of file SDL_test_fuzzer.c.

{
return SDLTest_RandomUint32() / (float) UINT_MAX;
}

References SDLTest_RandomUint32().

Referenced by pixels_calcGammaRamp(), and sdltest_randomNumber().

SDL_memset
#define SDL_memset
Definition: SDL_dynapi_overrides.h:386
Uint32
uint32_t Uint32
Definition: SDL_stdinc.h:203
Sint32
int32_t Sint32
Definition: SDL_stdinc.h:197
Sint64
int64_t Sint64
Definition: SDL_stdinc.h:210
SDLTest_GenerateSignedBoundaryValues
static Sint64 SDLTest_GenerateSignedBoundaryValues(const Sint64 minValue, const Sint64 maxValue, Sint64 boundary1, Sint64 boundary2, SDL_bool validDomain)
Definition: SDL_test_fuzzer.c:340
NULL
#define NULL
Definition: begin_code.h:167
b
GLboolean GLboolean GLboolean b
Definition: SDL_opengl_glext.h:1109
SDLTest_RandomUnitDouble
double SDLTest_RandomUnitDouble()
Definition: SDL_test_fuzzer.c:464
SDLTest_RandomAsciiStringOfSize
char * SDLTest_RandomAsciiStringOfSize(int size)
Definition: SDL_test_fuzzer.c:507
r
GLdouble GLdouble GLdouble r
Definition: SDL_opengl.h:2079
SDL_InvalidParamError
#define SDL_InvalidParamError(param)
Definition: SDL_error.h:54
SDLTest_RandomSint32
Sint32 SDLTest_RandomSint32()
Definition: SDL_test_fuzzer.c:111
rndContext
static SDLTest_RandomContext rndContext
Definition: SDL_test_fuzzer.c:56
SDLTest_RandomContext
Definition: SDL_test_random.h:59
a
GLboolean GLboolean GLboolean GLboolean a
Definition: SDL_opengl_glext.h:1109
SDLTest_GenerateUnsignedBoundaryValues
static Uint64 SDLTest_GenerateUnsignedBoundaryValues(const Uint64 maxValue, Uint64 boundary1, Uint64 boundary2, SDL_bool validDomain)
Definition: SDL_test_fuzzer.c:208
Sint16
int16_t Sint16
Definition: SDL_stdinc.h:185
counter
GLuint counter
Definition: SDL_opengl_glext.h:4992
fuzzerInvocationCounter
static int fuzzerInvocationCounter
Definition: SDL_test_fuzzer.c:51
SDLTest_RandomInt
#define SDLTest_RandomInt(c)
Definition: SDL_test_random.h:54
Uint16
uint16_t Uint16
Definition: SDL_stdinc.h:191
SDLTest_RandomUint32
Uint32 SDLTest_RandomUint32()
Definition: SDL_test_fuzzer.c:119
UINT64_MAX
#define UINT64_MAX
Definition: testvulkan.c:39
size
GLsizeiptr size
Definition: SDL_opengl_glext.h:537
SDLTest_RandomInit
void SDLTest_RandomInit(SDLTest_RandomContext *rndContext, unsigned int xi, unsigned int ci)
Initialize random number generator with two integers.
Definition: SDL_test_random.c:41
INT_MAX
#define INT_MAX
Definition: SDL_wave.c:31
value
GLsizei const GLfloat * value
Definition: SDL_opengl_glext.h:698
s
GLdouble s
Definition: SDL_opengl.h:2063
Uint64
uint64_t Uint64
Definition: SDL_stdinc.h:216
SDLTest_RandomUint64
Uint64 SDLTest_RandomUint64()
Definition: SDL_test_fuzzer.c:127
string
GLsizei const GLchar *const * string
Definition: SDL_opengl_glext.h:688
SDL_malloc
#define SDL_malloc
Definition: SDL_dynapi_overrides.h:374
Sint8
int8_t Sint8
Definition: SDL_stdinc.h:173
maxLength
GLsizei maxLength
Definition: SDL_opengl_glext.h:3644
SDLTest_RandomIntegerInRange
Sint32 SDLTest_RandomIntegerInRange(Sint32 pMin, Sint32 pMax)
Definition: SDL_test_fuzzer.c:163
SDLTest_RandomAsciiStringWithMaximumLength
char * SDLTest_RandomAsciiStringWithMaximumLength(int maxLength)
Definition: SDL_test_fuzzer.c:492
Uint8
uint8_t Uint8
Definition: SDL_stdinc.h:179